// levels.h

// Just to keep track of where levels are in RAM and
// to unpack them into main RAM.

// In a future, possible 48K version, here be code
// to load levels from tape and unpack them into the
// "current level buffers"

typedef struct {
	unsigned int title_screen_address;
	unsigned char *intro_cad;
	unsigned char ram_page;
	unsigned int tileset_address;
	unsigned int stage_1;
	unsigned int stage_2;
	unsigned int stage_3;
	unsigned int stage_4;
} WORLD;

extern unsigned char intro_cad1 [];
extern unsigned char intro_cad2 [];
extern unsigned char intro_cad3 [];
extern unsigned char intro_cad4 [];
extern unsigned char intro_cad5 [];

// Anjuel always reverses , and . in the charsets XD

#asm
	._intro_cad1
		defm "MARITRINI ARRIVES IN THE"
		defb 13
		defm "FOREST, "
		defb 34
		defm "I'M SURE THIS IS"
		defb 13
		defm "THE RIGHT PLACE"
		defb 34
		defm ". SHE"
		defb 13
		defm "THINKS TO HERSELF,"
		defb 0
	._intro_cad2
		defm "IN THE MIDDLE OF THE WOOD."
		defb 13
		defm "SHE FINDS A SCHOOL-LIKE"
		defb 13
		defm "COMPLEX, "
		defb 34
		defm "VERY SUSPICIOUS!"
		defb 34
		defb 13
		defm "SHE THINKS,"
		defb 0
	._intro_cad3
		defm "MARITRINI DISCOVERS THE"
		defb 13
		defm "SECRET ENTRANCE TO AN"
		defb 13
		defm "UNDERGROUND INSTALLATION"
		defb 13
		defb 34
		defm "INTERESTING,,,"
		defb 34
		defb 0
	._intro_cad4
		defm "MARITRINI KEEP DESCENDING"
		defb 13
		defm "UNTIL SHE HITS WHAT LOOKS"
		defb 13
		defm "LIKE AN UNDERGROUND MINE"
		defb 13
		defb 34
		defm "MISCHIEVOUS!"
		defb 34
		defb 0
	._intro_cad5
		defb 34
		defm "FINALLY, I THINK I FOUND"
		defb 13
		defm "IT!. THINKS MARITRINI,"
		defb 13
		defb 34
		defm "THIS MUST BE WHERE IT"
		defb 13
		defm "ALL CAME FROM!"
		defb 34
		defb 0
#endasm

WORLD worlds [7] = {
	{50926, intro_cad1, 4, 49152, 50616, 51471, 52371, 53341},
	{55993, intro_cad2, 4, 54133, 55517, 56246, 56991, 57563},
	{53955, intro_cad3, 4, 58219, 59607, 60441, 61226, 61936},
	{56898, intro_cad4, 6, 49152, 50597, 51387, 52170, 52792},
	{52403, intro_cad5, 6, 53416, 54901, 55678, 56551, 57197},
	{0, 0, 6, 57729, 58855, 0, 0, 0},
	{0, 0, 6, 59133, 60544, 0, 0, 0}
};

void prepare_world (unsigned char world, unsigned char level) {
	// Show title screen & wait for keypress
	
	wyz_play_music (0);
	
	if (worlds [world - 1].title_screen_address != 0 && level == 0) {
		unpack_RAMn (3, worlds [world - 1].title_screen_address, 16384, 1);
		draw_char_by_char (3, 14, worlds [world - 1].intro_cad);
		while (in_Inkey ());
		while (!in_Inkey ());
		fade_out ();
	}
	
	wyz_stop_sound ();
	
	// Unpack tileset
	unpack_RAMn (worlds [world - 1].ram_page, worlds [world - 1].tileset_address, (unsigned int) (dt_tileset), 0);
}

void prepare_stage (unsigned char world, unsigned char stage) {
	// Unpack map
	unsigned int address;
	
	switch (stage) {
		case 1:	
			address = worlds [world - 1].stage_1;
			break;
		case 2:	
			address = worlds [world - 1].stage_2;
			break;
		case 3:	
			address = worlds [world - 1].stage_3;
			break;
		case 4:	
			address = worlds [world - 1].stage_4;
			break;
	}
	
	unpack_RAMn	(worlds [world - 1].ram_page, address, (unsigned int) (dt_mapdata), 0);
}
